#!/usr/bin/env python2

# compares two lists of trees and creates a test file

import os, sys
from compare_one_dep_tree import get_dep_score
import argparse

# settings ###################################################################

parser = argparse.ArgumentParser()
parser.add_argument("-s", "--sentences", action="store_true",
        help="show results per sentence")
parser.add_argument("dirgold", type=str,
        help="directory with gold standard trees")
parser.add_argument("dirtest", type=str,
        help="directory trees to evaluate")
args = parser.parse_args()

#dir1 = './data/trees/pdt2_etest'
#dir2 = './data/trees/set_pdt2_etest'

dir1 = args.dirgold
dir2 = args.dirtest

not_sentences = not(args.sentences) # if True, not sentences are counted, only dependencies

# end settings ###############################################################

def pdt_name(i):
   return os.path.join(dir1, '%05d' % i)

def set_name(i):
   return os.path.join(dir2, '%05d' % i)



if __name__ == '__main__':
    i = 0
    global1 = []
    global2 = []
    for name2 in sorted(os.listdir(dir2)):
        if not os.path.isfile(os.path.join(dir2,name2)):
            continue
        try:
            f1 = open(os.path.join(dir1,name2))
            f2 = open(os.path.join(dir2,name2))
        except:
            continue
        list1 = []; list2 = []
        for line in f1:
            if len(line.split('\t')) >= 4: list1.append(line)
        for line in f2:
            if len(line.split('\t')) >= 4: list2.append(line)
        f1.close(); f2.close()
        if len(list1) == len(list2):
            if not_sentences: global1.extend(list1); global2.extend(list2)
            else: print name2 + '\t' + "UAS = %5.1f %%" % get_dep_score(list1, list2)
        else: sys.stderr.write('warning: skipped sentence No. %s (%d != %d)\n' %
                (name2, len(list1), len(list2)))

if not_sentences: print "UAS = %5.1f %%" % get_dep_score(global1, global2)

