#!/usr/bin/python2
# -*- coding: utf-8 -*-

import os, sys
from shutil import copyfile
import argparse

parser = argparse.ArgumentParser()
parser.add_argument("dir", type=str,
        help="directory with all verticals")
parser.add_argument("outdir", type=str,
        help="directory for storing the selected verticals")
args = parser.parse_args()

def vert_is_selected(name, tokens):
    punct = [t for t in tokens if t[2][0] == 'Z']
    verbs = [t for t in tokens
            if t[2][0] == 'V' and (t[2][1] != 'f' or t[1] == 'být')]
    ends = tokens[-1][1][0]

    selected = ((len(tokens)>4 and len(tokens)<13) and len(punct)==1 and
            ends in '.?!' and len(verbs)==1)
    print "%s-%s: %d, verbs %d, punct %d, ends='%s'" % (name,
            str(selected), len(tokens), len(verbs), len(punct), ends)
    return selected

for name in sorted(os.listdir(args.dir)):
    if not os.path.isfile(os.path.join(args.dir,name)):
        continue
    try:
        f = open(os.path.join(args.dir,name))
    except:
        continue

    tokens = []
    for line in f:
        if len(line.split('\t')) >= 3: tokens.append(line.split('\t'))

    if vert_is_selected(name, tokens):
        #pass
        copyfile(os.path.join(args.dir,name), os.path.join(args.outdir,name))

